const db = require('./db');

const authwrap = (fn) => async (msg, respond, socket, io) => {
	if (!respond)
		respond = () => {};
	if (!msg || !msg.__session) {
		return respond({
			success: false,
			message: 'not authenticated',
		});
	}
	const result = await db.query(
		`select user.* from user join authentication
		on authentication.user = user.id
		where authentication.salt = ?`,
		[msg.__session]
	);
	if (result.rows.length === 0) {
		return respond({
			success: false,
			message: 'user not found',
		});
	}
	return await fn({ ...msg, auth_user: result.rows[0] }, respond, socket, io);
};

module.exports = authwrap;
